from __future__ import division
import numpy as np
import scipy.special as special
import matplotlib.pyplot as plt


m=1
a=1
hbar=1

def density(n,t,x): 
    k_n=n*np.pi/a
    
    def Fresnel(y):
        k_n=n*np.pi/a
        chi=np.sqrt(m/(np.pi*hbar*t))*(hbar*k_n*t/m-y)
        sin_fresnel,cos_fresnel=special.fresnel(chi)
        return cos_fresnel+sin_fresnel*1j
    
    right_moving  =  np.exp(1j*k_n*x)  *  (Fresnel(x-a)-Fresnel(x))
    left_moving   =  np.exp(-1j*k_n*x) *  (Fresnel(a-x)-Fresnel(-x))
    
    return (4*a)**-1*abs(right_moving+left_moving)**2

T=[0.00001,0.05,0.1,0.2,1]
X=np.linspace(-a,a,100)
densities=[[density(1,t,x+a/2) for x in X] for t in T]

for den in densities: plt.plot(X,den)
plt.savefig('long_timescales.pdf')
plt.close()


T=[0.00001,0.00485,0.00513,0.0055]
X=np.linspace(-a/10,a/10,100)
densities=[[density(1,t,x+a/2) for x in X] for t in T]

for den in densities: plt.plot(X,den)
plt.savefig('Short_beating.pdf')
plt.close()


T=list(np.linspace(0.018,0.03,10))
X=np.linspace(-a/10,a/10,100)
densities=[[density(1,t,x+a/2) for x in X] for t in T]

for den in densities: plt.plot(X,den)
plt.savefig('Full_oscillation.pdf')
plt.close()